<script setup lang="ts">
import { uselistnamepayStore } from '@/stores/listnamepay'
import { type User, user } from '@/types/User'
import { onUnmounted, ref } from 'vue'
import Payback from '@/service/pay'


const listNamepay = uselistnamepayStore()
const users = ref<User[]>(user)

const email = ref('')
const password = ref('')
const dialog = ref(false)
const showPassword = ref()
const selectedOption = ref('one');
// Create a ref for newPay
const newPay = ref<any>(null)

function nameadd() {
  listNamepay.showAddDialog()
  const currentUserIndex = users.value.findIndex(
    (user) => user.email === email.value && user.password === password.value
  )

  if (currentUserIndex !== -1) {
    const currentUser = users.value.splice(currentUserIndex, 1)[0]

    const date1 = new Date(currentUser.timein).getTime()
    const date2 = new Date(currentUser.timeout).getTime()
    const hoursDifference = currentUser.timework
    // เปลี่ยน ทดลอง
    const totalWorkHours = 999

    if (!Number.isNaN(hoursDifference)) {
      newPay.value = { 
        id: currentUser.id,
        name: currentUser.fullName,
        date: new Date(),
        roles: currentUser.roles,
        salary: currentUser.timework * 330,
        status: '',
        workhours: currentUser.timework,
        
      }
      
      listNamepay.listnamepay.push(newPay.value)
      console.log(newPay.value)
      
    } else {
      console.log('Invalid!!!!!!!!!!!')
    }
  }

  resetForm()
}

// ยังเป็นจ่ายเงินต้องครบ 30 ครั้งอยู่
function Paymounth(users: { id: number }[]) {
  const idCountMap: { [key: number]: number } = users.reduce((acc, curr) => {
    acc[curr.id] = (acc[curr.id] || 0) + 1
    return acc
  }, {} as { [key: number]: number })
  const selectedIds = Object.keys(idCountMap).filter(id => idCountMap[Number(id)] >= 30)
  return selectedIds.map(id => Number(id)); // เพื่อให้ผลลัพธ์เป็นตัวเลข
}
function resetForm() {
  email.value = ''
  password.value = ''
}

// Call addPay function when the component is unmounted (i.e., after the dialog is closed)
onUnmounted(() => {
  if (newPay.value) {
    Payback.addPay(newPay.value)
    
  }
})
</script>

<template>
  <v-row justify="end">
    <v-dialog v-model="dialog" persistent width="1024">
      <template v-slot:activator="{ props }">
        <v-btn color="green" v-bind="props"> Add EM </v-btn>
      </template>
      <v-card class="custom-dialog-card">
        <v-card-title>
          <!-- <span class="text-h5">Add List Employee</span> -->
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12">
                <v-text-field label="Email" v-model="email" required></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field label="Password" v-model="password" :type="showPassword ? 'text' : 'password'" required></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-checkbox v-model="showPassword" label="Show Password"></v-checkbox>
              </v-col>

              <v-btn-toggle v-model="selectedOption" mandatory>
      <v-btn @click="selectedOption = 'one'" :class="{ 'btn-selected': selectedOption === 'one' }">รายวัน</v-btn>
      <v-btn @click="selectedOption = 'two';Paymounth(users)" :class="{ 'btn-selected': selectedOption === 'two' }">รายเดือน</v-btn>
    </v-btn-toggle>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="pink" variant="text" @click="dialog = false">Close</v-btn>
          <v-btn color="green" variant="text" @click="if(selectedOption === 'one') nameadd(); else  console.log('2'); dialog = false;">Save</v-btn>

        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<style scoped>
.custom-dialog-card {
  background-color: floralwhite;
}

.btn-selected {
  background-color: #42a5f5; /* Change to your desired selected color */
  color: white;
}
</style>
